# MaxAxe (Throw Things)

## Unleash Your Throwing Fury!

### Now with two-handed weapon throwing, realistic throwing dynamics, and throwing skill.

### Throw Axes, Knives, Maces, Swords, Sledges, Atgeirs, Battleaxes, Flaming Torches, Stones, Shields, Wisps, Eitr, Tankards & Eggs. Stack throwing weapons. Frostner returns when thrown!

- Ever wonder why a Viking's axe (of all things) wouldn't be a weapon of choice? And why you couldn't throw them?
- Throw Axes, Clubs, Torches, Swords, Knives, and Maces
- Throw two-handed weapons including Sledges, Battleaxes, Swords and Atgeirs.
- Channel the spirit of Mjolnir; throw Frostner and have it return! 
- Simulate more realistic throwing using 'Better' dynamics.
- Throw Shields. Unsling your round shield and send it spinning at your enemy like Cap.
- Throw Stones. Whack a Greyling, annoy a Troll, send feathers flying, be a Hobbit.
- Throw Tankards. Toast your friends, throw back a cold one, then throw your mug.
- Throw Wisps and Eitr and do substantial elemental or poison damage.
- Throw chicken Eggs. Toss eggs at your friends and do, well... let's just say it's yolky.
- Toggle between melee and throwing attacks with a key press.
- Optionally stack throwable weapons; up to 3 Axes, Clubs or Maces, a 'quiver' of 5 Spears, and a 'sheath' of 10 Knives per slot.
- Has a weapon 'finder' to help locate thrown weapons.
- MaxAxe can automatically equip a backup weapon so you're never fumbling to find another weapon in combat.

## New

- 0.4.1 Updated for Valheim patch 0.216
- 0.4.1 Removed elemental damage from thrown Eitr balls.
- 0.4.0 Added throwing Sledges, Battleaxes, Two-handed Swords, and Atgeirs.
- 0.4.0 Revised throwing skill to include accuracy and velocity modifiers (see _Throwing Skill_ below)
- 0.4.0 Fixed compatibilty with Azumatt's Mjolnir secondary attack in melee mode.
- 0.4.0 Added config to control automatically equiping picked up Shields; Picked up Shields will no longer swap out equipped two-handed weapons.
- 0.4.0 Adds a sledge secondary melee attack.

## Configuration

### General

- ***MeleeAttack***: If True, uses the melee secondary attack. Toggle in-game using the _ToggleMeleeAttack_ key.
- ***ToggleMeleeAttack***: Press this key to toggle in-game between Throw and Melee mode for secondary attacks on enabled one-handed weapons. Default is LeftAlt+B.
- ***ThrowOne***: Press this key (even in melee mode) to throw the currently equipped weapon (if throwable). Default is T.
- ***ThrowOnRelease***: Set to True to throw when the _ThrowOne_ or _ThrowShield_ keys are released instead of pressed. Default is False.
- ***ThrowShield***: Press this key to throw your currently equipped round shield. Default is G.
- ***UnderhandShield***: Set to True to throw your shield using an underhand throw. Shields must also be enabled. Default is False.

- **EnableAxes**: Set to True to enable secondary melee and throwing attacks for one-handed axes.
- **EnableClubs**: Set to True to enable secondary throwing attacks for clubs, including maces, Frostner, torches, stones & tankards.
- **EnableKnives**: Set to True to enable secondary throwing attack for knives.
- **EnableSpears**: Set to True to enable secondary melee attack for spears.
- **EnableSwords**: Set to True to enable secondary throwing attack for swords.
- **EnableShields**: Set to true to enable hurling your round shield with the _ThrowShield_ key. Your shield must be equipped.

- **WeaponStones**: Set to True to equip and attack with stones. Clubs must also be enabled.
- **WeaponWisps**: Set to True to equip and attack with Wisps.
- **WeaponEitr**: Set to True to equip and attack with Eitr. ***Note that handling Eitr can be dangerous***.
- **WeaponEggs**: Set to True to equip and 'attack' with Eggs.
- **WeaponTankards**: Set to True to equip and attack with Tankards.

- **MjolnirMode**: Set to True to have Frostner return to your hand after throwing. Default is False.
- **StackableWeapons**: Set to True to allow throwable weapons to stack. See _Stackable Weapons_ below before enabling.
- ***ThrowingStatus***: Set to True to display a status effect if throwing is active.
- **UseThrowingSkill**: Set to true to use a 'throwing' skill. Used in place of specific weapon skills to improve stats for all thrown items.
- ***AutoMelee***: Set to True to automatically switch to melee mode after weapon is thrown (or to prevent throwing the last weapon in a stack).
- ***AutoEquip***: Set to True to automatically equip another weapon after a throw. Will try to find the same weapon in inventory first.
- ***AutoEquipShields***: Set to True to automatically equip shields when picked up. Shield will not swap out an equipped two-handed weapon.
- ***TargetAdjustment***: Adjusts the vertical throwing impact point in relation to the target crosshair (the +). Default is -7. Vanilla Valheim is 0.
- **ThrowingMode**: Set to Better to use earth nominal gravity, factor weapon inertia into throwing and add drag by weapon type. See _Dynamics_ below.
- ***WeaponFinder***: Type of 'locator' effect added to thrown weapon to make it easier to find. Can be 'Wishbone', 'Autopick' or 'None'. Default is Wishbone.

### Utility

- ***LogLevel***: Controls the level of information in the log.
- ***ItemAmountColor***: Color of item quantity text in hotbar and inventory. Default is yellow (FFEB04FF). Active only when _StackableWeapons_ is true.
- ***ForceSimpleTrail***: Forces MaxAxe to use a "simple" trail.
- **ExcludePrefabs**: A comma delimited string of prefab names to exclude from MaxAxe as throwable items (e.g. PrefabNameA,PrefabNameB). See _Compatibility_ below.
- ***DisableIncompatibleMods***: When set to true, will automatically disable fully incompatible mods. See _Compatibility issues_ below. The log file will display a Warning. This setting only affects those mods that cause a critical issue with MaxAxe and have no known workaround.

### In-game reconfiguration

You can use Configuration Manager (or similar) mod to change the configuration without exiting the game. You can force a configuration update from the chat window (press Enter) then type:

	/maxaxe config
   
You can also change most settings using this syntax:

	/maxaxe [setting]=[value] , i.e., /maxaxe enableaxes=true

Note that the _EnableX_, _StackableWeapons_, _MjolnirMode_ and _WeaponX_ settings are controlled by the server in multiplayer.

### Stackable Weapons

**READ BEFORE ENABLING STACKABLE WEAPONS**

If you set _StackableWeapons_ to 'true', one-handed weapons will stack in both player and chest inventory.

If you have stacked weapons in your player inventory, you must unstack them before you can turn _StackableWeapons_ 'off' in-game. Caution: no warning exists for stacked weapons in chests.

If you still find yourself with stacked weapons after turning off stackables (for instance in chests, or inventory if you turned stackables off outside the game) you won't lose your stacked weapons, _BUT they are only there for 'safety'_ giving you an opportunity to unstack them. If you try to continue to use the items as stacked, strange things will happen, including losing stacked weapons.

***Split weapon stacks into individual weapons before you disable or uninstall MaxAxe***

- With version 0.3.0 any stacked weapons will still be accessible after _StackableWeapons_ is turned off, but will be split into individual weapons when transferred between containers and/or inventory.
- If there is not enough room in a container to split all weapons in a stack, any that don't fit will remain stacked until room is provided.
- The stackable 'autocheck" on load is no longer triggered (or needed, since stacks won't be 'lost')
- If you disable or uninstall MaxAxe any stacked weapons will 'revert' to single items once you restart without MaxAxe.

**Durability** Weapons have durability applied to each weapon in the stack separately (virtually). The durability bar will decrease on the weapon until it breaks. The broken weapon will be removed from the stack, and placed in a separate slot. The durability bar on the 'next' weapon in the stack will be 'full'. If additional weapons of the same type/level break, they will be stacked with existing broken weapons of the same type/level. **NOTE** _If no slot is available for the broken weapon, it will be dropped (but a weapon finder will be added)_.

- You can split stacks, but the split stack will have the same durability as the source stack.
- You cannot merge broken weapons into a stack with durability.
- You cannot merge durable weapons into a broken stack (prevents accidentally 'breaking' good weapons)
- You can merge durable weapons into a stack with different durability, but the merged stack will use the durability of the lesser.
- You can merge broken weapons of the same type/level together.
- If you pick up multiple thrown weapons, the stack will use the durability of the least durable weapon, i.e., the 'current' weapon will be the least durable (except if also using EQS).

### Dynamics

Setting Dynamics to "Better" will simulate the following:

- Earth nominal gravity of 9.81 m/s/s
- Inertia based on mass (i.e., weapon weight) applied to the initial velocity of the throw.
- Drag on thrown weapons based on weapon shape and size, e.g., Clubs are more affected by air resistance than spears.

Note that throwing weapons, particularly in this mode, can be more instinctive than "aimed". Set your crosshair to be 'trued' for your most desired throwing distance. 'Better' mode will try to adjusted this for the type of weapon being thrown, but throwing greater distances will have a sharper dropoff for less 'aerodynamic' weapon types.

### Throwing Skill

With version 0.4.0, the throwing skill will now also "turn on" throwing accuracy. The Throwing skill will be combined with (not added to) the thrown weapon skill for accuracy and damage adjustments (weighted toward the throwing skill). It will also slightly improve throwing velocity.

### Compatibility issues & known defects

- Please make sure you have the most recent versions of Adventure Backpacks and CombatIncentivesREwrite installed.
- _StackableWeapons_ is not compatible with Epic Loot. If you turn on stackable weapons with Epic Loot, EL will not be able to create/drop magical One Handed weapons. Existing weapons will continue to work.
- If you're using Dual Wield with _StackableWeapons_ and throw your weapon then pick it up, your weapon will be added to the stack and not re-equipped. You'll need to split the stack into two in order to re-equip your off-hand weapon.
- _StackableWeapons_ is mostly compatible with Jewelcrafting, however, an entire stack of weapons will _all_ be socketed with one socket crafting. In addition, once unstacked or thrown, socketed weapons will no longer stack.
- If you throw a weapon far enough it may not respawn. This is most likely to happen if you throw from a substantial height. This is not a MaxAxe issue - it can happen in 'vanilla' Valheim with thrown spears.
- MaxAxe has limited compatibility with Terraheim weapons:
	- Some weapons can be thrown, others cannot. Those that cannot will display a flashing Throwing status icon in Throwing mode. 
	- For incompatible weapons, the Terraheim secondary attack will still be triggered, regardless of whether MaxAxe is in Melee and Throwing mode.
- Some 'enhanced' weapons, particularly those with magical properties, may exhibit unusual behavior or result in errors when thrown by MaxAxe.
	- If you have an incompatible weapon and want to exclude it from being thrown, you can add its prefab name on a separate line in the text file _ExcludePrefabs.txt_ found in the Neobotics-MaxAxe folder.
	- MaxAxe will also exclude any prefabs listed in the _ExcludePrefabs_ configuration entry. These prefabs can be controlled by the server.
	- If you find any specfic incompatible weapons, please feel free to add a post on Nexus.
- The following mods are _not_ compatible with MaxAxe and have no known workaround. If you have _DisableIncompatibleMods_ set to true, they will be automatically disabled to allow MaxAxe to function correctly:
	- ValheimSecondaryAttacks (aka Swords Secondary do Piercing Damage) from anarkopsykotik, which will cause some thrown weapons to be duplicated. _But don't fret; **MaxAxe makes all the same adjustments** to melee secondary attacks of knives, swords, atgeirs and battleaxes._
	
- If you find a compatibility issue you can post it on NexusMods. Be sure to include the mod name and version you think may be incompatible.
- If you have a bug please report it on NexusMods. If you do post a bug report, please make sure to include the following:
    - Your version of this mod
    - What you were doing, or attempting to do when it happened
    - If it's repeatable - i.e., can you duplicate it?
    - The exact behavior you observed (or didn't observe)
    - If possible, post a capture of the log file with errors (errors always begin with this mod's name) on Discord

### Notes

- All config settings are server authoritative except those in ***bold italics***
- Wisps deliver a combination of all elemental type damage + spirit damage. The total damage is on-par with a Mistlands weapon.
- Eitr delivers poison damage. The total damage is on-par with a Mistlands weapon. **Handling Eitr can be hazardous to your health.** If an Eitr spark hits you while you have it equipped, ***you*** will take damage!
- Wisps and Eitr do not have a melee attack, and both are consumed on impact. Use improves the Elemental magic skill.
- Eggs just make a mess. Note that the egg is destroyed on impact.
- The Carapace Buckler is just not aerodynamic enough to throw. Maybe in a future release if I can get in a wobble.
- Multiplayer:
    - If a player clicks on a thrown item in-flight (unlikely but possible if you're a ninja or elf) a thrown weapon can be 'captured' by another player. It will not be 'auto' captured in flight if auto pickup is on.
    - If the attacker has PVP damage enabled, but the target does not, the target may automatically pick up the item after it hits. This is the same behavior as a thrown spear in vanilla Valheim.
- If using _ThrowOnRelease_ with a multi key combo, both keys must be released at *exactly* the same time. A single key is recommended.
- MjolnirMode is intended for fun, not roleplay. It only works with Frostner and Mjolnir (from Azumatt).
    - Try not to throw it into deep water. If you do, you may need to move closer before it returns, and it may take a little time.
	- The return speed matches the weapon speed...there has to be _some_ degree of balance here!
- You cannot upgrade weapons in a stack. Unstack a weapon before upgrading.
- Torches will remain lit for a short time after being thrown. Toss into dark areas for a bit of light!
- The spear secondary melee attack uses a powerful spear 'thrust'. Unfortunately the spear is pointed in the wrong direction(!), so this is done with the spear's butt, and therefore delivers Blunt damage.
- Damage from Atgeir and Battleaxe secondary attacks are adjusted to reflect the use of the weapon in the attack (slash and blunt respectively)
- Weapon finders are not persisted between sessions. If you don't pick up a weapon and log off, it will no longer display a finder.
- Shields deliver attack damage equivalent to their Block damage, but do not factor in Blocking skill to the damage.
- Thrown (and melee) tankard attacks don't require mead in your inventory.
- If _StackableWeapons_ is true, _all_ stacked items amount text will appear in the color configured by _ItemAmountColor_
- If you need to exclude a prefab, but don't know it's name, you can set the Log level to "Debug" and attempt to throw the item. The console and log file should have an entry that begins with "Attacking with prefab" followed by the prefab name. Don't forget to set the Log level back to "Info" or above.
- Frostner needs an open inventory slot to return. If your inventory is full, it will fall to the ground with a weapon finder, however, autopickup will not work - you'll have to pick it up 'by hand'.
- Sorry, but throwing weapon trails and shield rotation/decoration in flight are not visible to other players (yet)
 

You can find all Neobotics released mods on: 
- Thunderstore: https://tinyurl.com/NeoboticsOnThunderstore 
- Nexus Mods: https://tinyurl.com/NeoboticsOnNexus

Your comments and feedback are always welcome. Post on NexusMods or Discord: https://tinyurl.com/NeoboticsOnDiscord

